/***************************************************************************
 * Copyright 2012 by
 *  + Christian-Albrechts-University of Kiel
 *    + Department of Computer Science
 *      + Software Engineering Group 
 *  and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ***************************************************************************/

package kieker.webgui.common;

import kieker.analysis.AnalysisController;
import kieker.analysis.model.analysisMetaModel.MIInputPort;
import kieker.analysis.model.analysisMetaModel.MIOutputPort;
import kieker.analysis.model.analysisMetaModel.MIPlugin;
import kieker.analysis.plugin.AbstractPlugin;

/**
 * 
 * @author Nils Christian Ehmke
 */
public class Connection {

	private MIPlugin source;
	private MIPlugin destination;
	private MIInputPort inputPort;
	private MIOutputPort outputPort;

	public Connection(MIPlugin source, MIPlugin destination, MIInputPort inputPort, MIOutputPort outputPort) {
		this.source = source;
		this.destination = destination;
		this.inputPort = inputPort;
		this.outputPort = outputPort;
	}

	public MIPlugin getDestination() {
		return destination;
	}

	public void setDestination(MIPlugin destination) {
		this.destination = destination;
	}

	public MIInputPort getInputPort() {
		return inputPort;
	}

	public void setInputPort(MIInputPort inputPort) {
		this.inputPort = inputPort;
	}

	public MIOutputPort getOutputPort() {
		return outputPort;
	}

	public void setOutputPort(MIOutputPort outputPort) {
		this.outputPort = outputPort;
	}

	public MIPlugin getSource() {
		return source;
	}

	public void setSource(MIPlugin source) {
		this.source = source;
	}

	public boolean isValid() {
		if (source == null || destination == null || inputPort == null || outputPort == null) {
			return false;
		}
		// TODO: This is not necessarily valid currently
		return true;
	}
}
