package kieker.webgui.converter;

import java.util.HashMap;
import java.util.concurrent.ConcurrentHashMap;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import kieker.analysis.model.analysisMetaModel.MIPlugin;

/**
 * 
 * @author Nils Christian Ehmke
 */
@FacesConverter(value = MIPluginToStringConverter.NAME)
public class MIPluginToStringConverter implements Converter {
	/**
	 * This is the name of this converter.
	 */
	public static final String NAME = "kieker.webgui.converter.MIPluginToStringConverter";

	private static ConcurrentHashMap<String, MIPlugin> map = new ConcurrentHashMap<String, MIPlugin>();

	/**
	 * Creates a new instance of this class.
	 */
	public MIPluginToStringConverter() {

	}

	@Override
	public Object getAsObject(final FacesContext fc, final UIComponent uic, final String string) {
		return map.get(string);
	}

	@Override
	public String getAsString(final FacesContext fc, final UIComponent uic, final Object o) {
		String result = o.toString();
		map.put(result, (MIPlugin) o);
		return result;
	}
}
